package com.example.maillard_clovis_event_manager.ui.register;

import androidx.lifecycle.LiveData;
import androidx.lifecycle.MutableLiveData;
import androidx.lifecycle.ViewModel;
import com.example.maillard_clovis_event_manager.R;

public class RegisterViewModel extends ViewModel {

    private MutableLiveData<RegisterFormState> registerFormState = new MutableLiveData<>();
    LiveData<RegisterFormState> getRegisterFormState() {
        return registerFormState;
    }

    public void registerDataChanged(String firstname, String lastname, String email, String password, String confirmPassword) {
        registerFormState.setValue(new RegisterFormState(false));
        //on ne test pas les champs vides
        if (!isFirstNameValid(firstname)&& !firstname.isEmpty()){
            registerFormState.setValue(new RegisterFormState(R.string.invalid_firstname, null, null, null, null));
        } else if (!isLastNameValid(lastname)&& !lastname.isEmpty()) {
            registerFormState.setValue(new RegisterFormState(null, R.string.invalid_lastname, null, null, null));
        } else if (!isEmailValid(email)&& !email.isEmpty()) {
            registerFormState.setValue(new RegisterFormState(null, null,  R.string.invalid_email, null, null));
        } else if (!isPasswordValid(password)&& !password.isEmpty()) {
            registerFormState.setValue(new RegisterFormState(null, null, null, R.string.invalid_password, null));
        } else if (!isConfirmPasswordValid(password, confirmPassword) && !confirmPassword.isEmpty()) {
            registerFormState.setValue(new RegisterFormState(null, null, null, null, R.string.invalid_confirmpassword));
        } else if(!firstname.isEmpty() && !lastname.isEmpty()&& !email.isEmpty()&& !password.isEmpty() && !confirmPassword.isEmpty()){
            registerFormState.setValue(new RegisterFormState(true));
        }
    }

    private boolean isPasswordValid(String password) {
        return password != null && password.trim().length() > 5;
    }

    private boolean isConfirmPasswordValid(String password, String confirm) {
        return password.equals(confirm);
    }

    private boolean isFirstNameValid(String firstname) {
        return firstname != null && !firstname.isEmpty();
    }

    private boolean isLastNameValid(String lastname) {
        return lastname != null && !lastname.isEmpty();
    }

    private boolean isEmailValid(String email) {
        return email != null && !email.isEmpty();
    }

}
